import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;


public class DBTools {
	
	
	
	Connection con;
	Statement statem;
	String[] connectionStr;
	
	
	public DBTools(String connectionFile) throws IOException {
		
		BufferedReader file = new BufferedReader(new FileReader(connectionFile));
		int n = Integer.parseInt(file.readLine());
		connectionStr = new String[n];
		String linha;
		int i = 0;
		while((linha = file.readLine())!=null){
			if(!linha.contains("#") ){
				connectionStr[i] = linha;
				i++;
			}
			
		}
					
	}
	
	public void conectar() throws ClassNotFoundException, SQLException, InstantiationException, IllegalAccessException, FileNotFoundException{
		
		Class.forName(this.connectionStr[0]);
	//	this.con = (Connection) DriverManager.getConnection("jdbc:mysql://150.161.28.147:3306/mysql","root","1after909");
		this.con = (Connection) DriverManager.getConnection("jdbc:"+connectionStr[1]+"://"+connectionStr[2]+":"+connectionStr[3]+"/"+ connectionStr[4], ""+connectionStr[5]+"", ""+connectionStr[6]+"");
		this.statem = con.createStatement();
		
		String url ;
		
		
	}
	public String[] listarTabelas() throws SQLException{
		String[] tabelas;
		int indice;
		int nTabelas;
		nTabelas = 0;
		ResultSet res;
		res = this.statem.executeQuery("SELECT name FROM sqlite_master WHERE type='table' UNION ALL SELECT name FROM sqlite_temp_master WHERE type='table' ORDER BY name");
		while(res.next()){
			nTabelas++;
		}
		tabelas = new String[nTabelas];
		indice = 0;
		res = this.statem.executeQuery("SELECT name FROM sqlite_master WHERE type='table' UNION ALL SELECT name FROM sqlite_temp_master WHERE type='table' ORDER BY name");
		while(res.next()){
			tabelas[indice] = res.getString(1);
			indice++;
		}
		return tabelas;
	}
	
	public boolean existeTabela(String nome) throws SQLException{
		boolean existe;
		String[] tabelas;
		int nTabela;
		nTabela = 0;
		tabelas = listarTabelas();
		existe = false;
		while(!existe && nTabela < tabelas.length){
			if(tabelas[nTabela].equals(nome)){
				existe = true;
			}
			else nTabela++;
		}
		return existe;
		
	}
	
	/**
	 * Método parar criar tabela no banco de dados 
	 * @param colunas - Array de String que representam as colunas da tabela e seus respectivos tipos. Cada String deverá estar no formato "nomedaColuna tipo"
	 * @param indiceChavePrimaria - indica o índice da String no array 'colunas' que corresponde à chave primária da tabela. 
	 * @throws SQLException 
	 * @throws ClassNotFoundException 
	 * @throws IllegalAccessException 
	 * @throws InstantiationException 
	 * @throws FileNotFoundException 
	 */
	public void criarTabela(String nomeTabela, String[] colunas, int indiceChavePrimaria) throws SQLException, ClassNotFoundException, InstantiationException, IllegalAccessException, FileNotFoundException{
		
		conectar();
		StringBuilder createTable;
		createTable = new StringBuilder("CREATE TABLE ");
		createTable.append(nomeTabela);
		createTable.append("(");
		
		for(int i = 0; i < colunas.length; i++){
			
			createTable.append(colunas[i]);
			if(i%2 == 0) createTable.append(" ");
			else createTable.append(",");
				
		}
		
		createTable.append("PRIMARY KEY(");
		createTable.append(colunas[indiceChavePrimaria]);
		createTable.append("))");
		//System.out.println(createTable.toString());
		this.statem.execute(createTable.toString());
		desconectar();
		
	}
	void apagarTabela(String tbName) throws ClassNotFoundException, SQLException, InstantiationException, IllegalAccessException, FileNotFoundException{
		
		conectar();
		this.statem = this.con.createStatement();
		statem.execute("DROP TABLE "+tbName);
		desconectar();
		
		
	}
	
	public void desconectar() throws SQLException{
		
		this.con.close();
		this.statem.close();
		
	}
	
	void inserirDadosTabela(String tbNome,String[] campos, String[] valores) throws ClassNotFoundException, SQLException, InstantiationException, IllegalAccessException, FileNotFoundException{
		
		conectar();
		StringBuilder insert;
		insert = new StringBuilder("INSERT INTO ");
		insert.append(tbNome);
		insert.append("(");
		for(int i = 0; i < campos.length; i++){
			
			insert.append(campos[i]);
			if(i < campos.length-1){
				insert.append(",");
			}
					
		}
		insert.append(") VALUES(");
		for(int i = 0; i < valores.length; i++){
			
			insert.append(valores[i]);
			if(i < valores.length-1){
				insert.append(",");
			}
			
		}
		insert.append(")");
		try{
		this.statem.executeUpdate(insert.toString());
		}
		catch(Exception e){
			e.printStackTrace();
		}
		
		
		desconectar();
	}
	
	StringBuilder[] selectTudoDe(String tbNome, String campo, String valor, int nColunas) throws ClassNotFoundException, SQLException, InstantiationException, IllegalAccessException, FileNotFoundException{
		
		StringBuilder select;
		ResultSet resultado;
		StringBuilder[] strResultado;
		int nLinhas;
		int linha;
		select = new StringBuilder("SELECT * FROM ");
		select.append(tbNome);
		select.append(" WHERE ");
		select.append(campo);
		select.append("=");
		select.append(valor);
		conectar();
		resultado = this.statem.executeQuery(select.toString());
		nLinhas = 0;
		
		while(resultado.next()){
			nLinhas++;
		}
		strResultado = new StringBuilder[nLinhas];
		for(int i = 0; i < nLinhas; i++){
			strResultado[i] = new StringBuilder("");
		}
		resultado = this.statem.executeQuery(select.toString());
		linha = 0;
		while(resultado.next()){
			for(int i = 1; i <= nColunas; i++){
				strResultado[linha].append(resultado.getString(i));
				if(i <= nColunas-1) strResultado[linha].append("\n");
			}
			linha++;
		}
		desconectar();
		return strResultado;
		
	}
	
	public void criarDB(String dbNome) throws FileNotFoundException, ClassNotFoundException, SQLException, InstantiationException, IllegalAccessException{
		
		conectar();
		getStatem().execute("CREATE DATABASE "+dbNome);
		desconectar();
		
		
	}
//	public boolean existeTabela(String nome){
//		boolean existe;
//		existe = false; 
//		conectar();
//		existe = this.statem.
//		return this.
//	}

//	public String getDbNome() {
//		return dbNome;
//	}
//
//	public void setDbNome(String dbNome) {
//		this.dbNome = dbNome;
//	}

	public Connection getCon() {
		return con;
	}

	public void setCon(Connection con) {
		this.con = con;
	}

	public Statement getStatem() {
		return statem;
	}

	public void setStatem(Statement statem) {
		this.statem = statem;
	}
	
	
}
